﻿// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "LMAmmoType.h"
#include "Components/ActorComponent.h"
#include "LMItemDropComponent.generated.h"

class ALMAmmoPack;
class ALMHealthPack;

UCLASS(Blueprintable, ClassGroup=(Custom), meta=(BlueprintSpawnableComponent))
class LEGUMEMIX_API ULMItemDropComponent : public UActorComponent
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category=Legumix, meta=(AllowPrivateAccess=true))
	TObjectPtr<UCurveFloat> DropChanceAtRemainingAmmo;

	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category=Legumix, meta=(AllowPrivateAccess=true, ClampMin=0, ClampMax=100, UIMin=0, UIMax=100))
	float DropChanceHealthPack = 10.f;

	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category=Legumix, meta=(AllowPrivateAccess=true))
	EAmmoType AmmoType = EAmmoType::EAT_CornAmmo;
	
	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category=Legumix, meta=(AllowPrivateAccess=true))
	TSubclassOf<ALMAmmoPack> AmmoPack;
	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category=Legumix, meta=(AllowPrivateAccess=true))
	TSubclassOf<ALMHealthPack> HealthPack;

public:
	ULMItemDropComponent();

	UFUNCTION(BlueprintCallable)
	void TryDropItems();
	UFUNCTION(BlueprintCallable)
	void SpawnAmmo();
	UFUNCTION(BlueprintCallable)
	void SpawnHealth();
};
